# `debugger_visualizer`

The tracking issue for this feature is: [#95939]

[#95939]: https://github.com/rust-lang/rust/issues/95939

------------------------

The `debugger_visualizer` attribute can be used to instruct the compiler
to embed a debugger visualizer file into the PDB/ELF generated by `rustc`.

## Examples

``` rust,ignore (partial-example)
#![feature(debugger_visualizer)]
#![debugger_visualizer(natvis_file = "foo.natvis")]
struct Foo {

}
```

## Limitations

Currently, this feature only supports embedding Natvis files on `-windows-msvc`
targets when using the MSVC linker via the `natvis_file` meta item.
